//+------------------------------------------------------------------+
//|                                               WMA_Oscillator.mq4 |
//|                             Copyright (c) 2016, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//|                                   Paypal: https://goo.gl/9Rj74e  | 
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |                    
//|                                          mario.jemic@gmail.com   |
//|                   BitCoin : 15VCJTLaz12Amr7adHSBtL9v8XomURo9RF   |
//+------------------------------------------------------------------+



#property indicator_buffers 2
#property indicator_separate_window

enum e_price{ CLOSE=PRICE_CLOSE, OPEN=PRICE_OPEN, LOW=PRICE_LOW, HIGH=PRICE_HIGH, MEDIAN=PRICE_MEDIAN, TYPICAL=PRICE_TYPICAL, WEIGHTED=PRICE_WEIGHTED };

extern int     WMA1_Period =  5;
extern int     WMA2_Period = 20;
extern e_price Price_Type  = CLOSE;
extern color   Up_Color    = clrLime;
extern color   Dn_Color    = clrRed;
extern int     Bars_Width  = 3;

double UP[];
double DOWN[];
double DATA[];
double Price[];
double WMA1[];
double WMA2[];

int init(){
   
   IndicatorShortName("WMA Oscillator");
   IndicatorBuffers(6);
   
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,Bars_Width,Up_Color);
   SetIndexBuffer(0,UP);
   SetIndexLabel(0,"UP");
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,Bars_Width,Dn_Color);
   SetIndexBuffer(1,DOWN);
   SetIndexLabel(1,"DOWN");
   SetIndexBuffer(2,DATA); 
   SetLevelValue(0,0);
   
   return(0);
}

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   for(int i=limit; i>=0; i--)
   {
      DATA[i] = iMA(NULL,0,WMA1_Period,0,MODE_SMMA,(int)Price_Type,i)-iMA(NULL,0,WMA2_Period,0,MODE_SMMA,(int)Price_Type,i);
      UP[i]   = (i<Bars-1) ? (DATA[i] > DATA[i+1]) ? DATA[i] : EMPTY_VALUE : EMPTY_VALUE;
      DOWN[i] = (i<Bars-1) ? (DATA[i] < DATA[i+1]) ? DATA[i] : EMPTY_VALUE : EMPTY_VALUE;
   }
   return(0);
}